"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KoaService = void 0;
const bodyparser_1 = __importDefault(require("@koa/bodyparser"));
const cors_1 = __importDefault(require("@koa/cors"));
const koa_1 = __importDefault(require("koa"));
class KoaService {
    constructor(config) {
        this.port = 7102;
        Object.assign(this, config !== null && config !== void 0 ? config : {});
    }
    start(...args) {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    serve(port) {
        return __awaiter(this, void 0, void 0, function* () {
            this.port = port !== null && port !== void 0 ? port : this.port;
            const app = new koa_1.default();
            app.use((0, cors_1.default)());
            app.use((0, bodyparser_1.default)());
            app.use(this.onRequest.bind(this));
            app.listen(this.port);
        });
    }
    onRequest(koaCtx) {
        return __awaiter(this, void 0, void 0, function* () { });
    }
}
exports.KoaService = KoaService;
exports.default = KoaService;
//# sourceMappingURL=KoaService.js.map