import bodyParser from '@koa/bodyparser'
import cors from '@koa/cors'
import Koa from 'koa'
import KoaCtx from './KoaCtx'

export abstract class KoaService {
	//----------------
	// CONSTRUCTOR
	//----------------
	constructor(config?: Partial<KoaService>) {
		Object.assign(this, config ?? {})
	}

	//----------------
	// PROPERTIES
	//----------------
	port: number = 7102

	//----------------
	// METHODS
	//----------------
	async start(...args: any[]) {}

	async serve(port?: number) {
		this.port = port ?? this.port

		const app = new Koa()
		app.use(cors())
		app.use(bodyParser())
		app.use(this.onRequest.bind(this))
		app.listen(this.port)
	}

	//----------------
	// EVENTS
	//----------------
	async onRequest(koaCtx: KoaCtx) {}
}
export default KoaService
